# PhysicalConstants.jl

| **Documentation**                       | **Build Status**                    | **Code Coverage**               |
|:---------------------------------------:|:-----------------------------------:|:-------------------------------:|
| [![][docs-stable-img]][docs-stable-url] | [![Build Status][gha-img]][gha-url] | [![][coveral-img]][coveral-url] |
| [![][docs-latest-img]][docs-latest-url] |                                     | [![][codecov-img]][codecov-url] |

Introduction
------------

`PhysicalConstants.jl` provides common physical constants.  They are defined as
instances of the new `Constant` type, which is subtype of `AbstractQuantity`
(from [`Unitful.jl`](https://github.com/PainterQubits/Unitful.jl) package) and can
also be turned into `Measurement` objects (from
[`Measurements.jl`](https://github.com/JuliaPhysics/Measurements.jl) package) at
request.

Constants are grouped into different submodules, so that the user can choose
different datasets as needed.  Currently, 2014, 2018, and 2022 editions of
[CODATA](https://physics.nist.gov/cuu/Constants/) recommended values of the
fundamental physical constants are provided.

Installation
------------

The latest version of `PhysicalConstants.jl` is available for Julia 1.0 and
later versions, and can be installed with [Julia built-in package
manager](https://julialang.github.io/Pkg.jl/stable/).  After entering the
package manager mode by pressing `]`, run the command

```julia
pkg> add PhysicalConstants
```

Usage
-----

You can load the package as usual with `using PhysicalConstants` but this module
does not provide anything useful for the end-users.  You most probably want to
directly load the submodule with the dataset you are interested in.  For
example, for CODATA 2022 load `PhysicalConstants.CODATA2022`:

```julia
julia> using PhysicalConstants.CODATA2022

julia> SpeedOfLightInVacuum
Speed of light in vacuum (c_0)
Value                         = 2.99792458e8 m s^-1
Standard uncertainty          = (exact)
Relative standard uncertainty = (exact)
Reference                     = CODATA 2022

julia> NewtonianConstantOfGravitation
Newtonian constant of gravitation (G)
Value                         = 6.6743e-11 m^3 kg^-1 s^-2
Standard uncertainty          = 1.5e-15 m^3 kg^-1 s^-2
Relative standard uncertainty = 2.2e-5
Reference                     = CODATA 2022
```

`SpeedOfLightInVacuum` and `NewtonianConstantOfGravitation` are two of the
`PhysicalConstant`s defined in the `PhysicalConstants.CODATA2022` module, the
full list of available constants is given below.

`PhysicalConstant`s can be readily used in mathematical operations, using by
default their `Float64` value:

```julia
julia> import PhysicalConstants.CODATA2022: c_0, ε_0, μ_0

julia> 2 * ε_0
1.77083756376e-11 F m^-1

julia> ε_0 - 1 / (μ_0 * c_0 ^ 2)
1.0567555442791707e-23 A^2 s^4 kg^-1 m^-3
```

If you want to use a different precision for the value of the constant, use the
function `float(float_type, constant)`, for example:

```julia
julia> float(Float32, ε_0)
8.854188f-12 F m^-1

julia> float(BigFloat, ε_0)
8.854187818800000000000000000000000000000000000000000000000000000000000000000059e-12 F m^-1

julia> big(ε_0)
8.854187818800000000000000000000000000000000000000000000000000000000000000000059e-12 F m^-1

julia> big(ε_0) - inv(big(μ_0) * big(c_0)^2)
1.056704162590924117341831987227432956066714823419574007586677144869010778731235e-23 A^2 s^4 kg^-1 m^-3
```

Note that `big(constant)` is an alias for `float(BigFloat, constant)`.

If in addition to units you also want the standard uncertainty associated with
the constant, use `measurement(x)`:

```julia
julia> using Measurements

julia> import PhysicalConstants.CODATA2022: h, ħ

julia> measurement(ħ)
1.0545718176461565e-34 ± 0.0 J s

julia> measurement(Float32, ħ)
1.0545718e-34 ± 0.0 J s

julia> measurement(BigFloat, ħ)
1.054571817646156391262428003302280744722826330020413122421923470598435912734741e-34 ± 0.0 J s

julia> measurement(BigFloat, ħ) / (measurement(BigFloat, h) / (2 * big(pi)))
1.0 ± 0.0
```

For more information read the
[documentation](https://juliaphysics.github.io/PhysicalConstants.jl/stable/),
which includes the full list of constants defined by the package.

License
-------

The `PhysicalConstants.jl` package is licensed under the MIT "Expat" License.
The original author is [Mosè Giordano](https://github.com/giordano/).


[docs-latest-img]: https://img.shields.io/badge/docs-latest-blue.svg
[docs-latest-url]: https://juliaphysics.github.io/PhysicalConstants.jl/dev/

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://juliaphysics.github.io/PhysicalConstants.jl/stable/

[gha-img]: https://github.com/JuliaPhysics/PhysicalConstants.jl/workflows/CI/badge.svg
[gha-url]: https://github.com/JuliaPhysics/PhysicalConstants.jl/actions?query=workflow%3ACI

[coveral-img]: https://coveralls.io/repos/github/JuliaPhysics/PhysicalConstants.jl/badge.svg?branch=master
[coveral-url]: https://coveralls.io/github/JuliaPhysics/PhysicalConstants.jl?branch=master

[codecov-img]: https://codecov.io/gh/JuliaPhysics/PhysicalConstants.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaPhysics/PhysicalConstants.jl

using Documenter, PhysicalConstants, Unitful
using PhysicalConstants: CODATA2014, CODATA2018, CODATA2022

## Generate list of constants
open(joinpath(@__DIR__, "src", "constants.md"), "w") do io
    print(io, """
              ## List of Set of Constants

              !!! note

                  Each dataset listed below exports by default only the full
                  long names of the constants.  Short aliases are provided for
                  convenience, but they are not exported, to avoid polluting
                  the main namespace with dozens of short-named variables.
                  Users can to import the short names of the variables they
                  use most frequently, as shown in the examples above.
              """
          )
    for set in (CODATA2014, CODATA2018, CODATA2022)
        println(io)
        println(io, "### ", nameof(set))
        println(io)
        constants = names(set)
        others = setdiff(names(set, all = true), constants)
        println(io, "| Long name | Short | Value | Unit |")
        println(io, "| --------- | ----- | ----- | ---- |")
        for constant in constants
            c = getfield(set, constant)
            if c isa PhysicalConstants.PhysicalConstant
                sym = others[findall(x -> c === getfield(set, x), others)][1]
                println(io, "| `", constant, "` | `", sym, "` | ", ustrip(float(c)), " | ",
                        unit(c) == Unitful.NoUnits ? "" : "`$(unit(c))`", " |")
            end
        end
    end
end

## Build docs
makedocs(
    modules = [PhysicalConstants],
    sitename = "PhysicalConstants",
    pages    = [
        "Introduction" => "index.md",
        "Usage" => "usage.md",
        "List of Constants" => "constants.md",
        "API Reference" => "reference.md",
    ]
)

### Deploy docs
deploydocs(
    repo = "github.com/JuliaPhysics/PhysicalConstants.jl.git",
    target = "build",
    deps = nothing,
    make = nothing,
    push_preview = true,
)

Base.promote_rule(::Type{PhysicalConstant{name,S,D,SU}},
                  ::Type{Quantity{T,D,TU}}) where {name,S,T,D,SU,TU} =
                      promote_type(Quantity{S,D,SU}, Quantity{T,D,TU})
Base.promote_rule(::Type{Quantity{T,D,TU}},
                  ::Type{PhysicalConstant{name,S,D,SU}}) where {name,S,T,D,SU,TU} =
                      promote_type(Quantity{S,D,SU}, Quantity{T,D,TU})

Base.promote_rule(::Type{PhysicalConstant{name,S,NoDims,U}},
                  ::Type{T}) where {name,S,U,T<:Number} =
                      promote_type(S, T)
Base.promote_rule(::Type{PhysicalConstant{name,S,NoDims,U}},
                  ::Type{Quantity{T,NoDims,TU}}) where {name,S,U,T,TU} =
                      promote_type(S, T)

Base.convert(::Type{T},
             x::PhysicalConstant{name,S,NoDims,U}) where {T<:AbstractFloat,name,S,U} =
                 float(T, x)

Unitful.uconvert(u::Unitful.Units, c::PhysicalConstant{name,T,D,TU}) where {name,T,D,TU} =
    uconvert(u, float(T, c))

module PhysicalConstants

using Measurements, Unitful

import Measurements: value, uncertainty
import Unitful: AbstractQuantity

# The type

"""
    PhysicalConstant{name,T,D,U} <: AbstractQuantity{T,D,U}

A type representing a physical constant, with units and -- optionally -- with
error as standard deviation.

Each type is a singleton and is parametrised by

* `name`: a `Symbol` representing its name
* `T`: the numerical type of the constant, e.g. `Float64`
* `D`: the physical dimension, from [`Unitful.jl`](https://painterqubits.github.io/Unitful.jl/stable/)
* `U`: the physical unit, from [`Unitful.jl`](https://painterqubits.github.io/Unitful.jl/stable/)

See [`@constant`](@ref) and [`@derived_constant`](@ref) for how to define a new
physical constant.
"""
struct PhysicalConstant{name,T,D,U} <: AbstractQuantity{T,D,U} end

_name(::PhysicalConstant{name,T,D,U}) where {name,T,D,U} = name

# Functions composing the building blocks of the macros

function _constant_preamble(name, sym, unit, val, def)
    ename = esc(name)
    qname = esc(Expr(:quote, name))
    esym = esc(sym)
    qsym = esc(Expr(:quote, sym))
    eunit = esc(unit)
    e_val = esc(val)
    _bigconvert = isa(def,Symbol) ? quote
        function _big(::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U}
            c = BigFloat()
            ccall(($(string("mpfr_const_", def)), :libmpfr),
                  Cint, (Ref{BigFloat}, Int32), c, MPFR.ROUNDING_MODE[])
            return c
        end
    end : quote
        _big(::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} = $(esc(def))
    end
    return ename, qname, esym, qsym, eunit, e_val, _bigconvert
end

function _constant_begin(qname, ename, esym, eunit, e_val, _bigconvert)
    quote
        const $ename = PhysicalConstant{gensym($qname),Float64,dimension($eunit),typeof($eunit)}()
        export $ename
        const $esym = $ename

        Base.float(::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} = $e_val * $eunit
        Base.float(FT::DataType, ::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} =
            FT($e_val) * $eunit
        $_bigconvert
        Base.big(x::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} = _big(x) * $eunit
        Base.float(::Type{BigFloat}, x::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} = big(x)
    end
end

function _constant_end(qname, ename, qsym, edescr, e_val, ereference, eunit)
    quote
        Measurements.measurement(::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} =
            measurement(Float64, $ename)

        Unitful.unit(::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U}      = $eunit
        Unitful.dimension(::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} = D

        PhysicalConstants.reference(::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} = $ereference

        function Base.show(io::IO, ::MIME"text/plain", x::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U}
            unc = uncertainty(ustrip(measurement($ename)))
            println(io, $edescr, " (", $qsym, ")")
            println(io, "Value                         = ", float($ename))
            println(io, "Standard uncertainty          = ",
                    iszero(unc) ? "(exact)" : unc * $eunit)
            println(io, "Relative standard uncertainty = ",
                    iszero(unc) ? "(exact)" : round(unc / $e_val, sigdigits=2))
            print(io,   "Reference                     = ", reference($ename))
        end

        @assert isa(ustrip(float($ename)), Float64)
        @assert isa(ustrip(big($ename)), BigFloat)
        @assert isa(ustrip(measurement($ename)), Measurement{Float64})
        @assert isa(ustrip(measurement(Float32, $ename)), Measurement{Float32})
        @assert ustrip(float(Float64, $ename)) == Float64(ustrip(big($ename)))
        @assert ustrip(float(Float32, $ename)) == Float32(ustrip(big($ename)))
        @assert isapprox(Float64(value(ustrip(measurement(BigFloat, $ename)))),
                         value(ustrip(measurement($ename))), rtol = 1e-15)
        @assert Float64(uncertainty(ustrip(measurement(BigFloat, $ename)))) ==
            uncertainty(ustrip(measurement($ename)))
        @assert ustrip(big($ename)) == value(ustrip(measurement(BigFloat, $ename)))
    end
end

# Currently AbstractQuantity defines some operations in terms of the inner field `val`.

function Base.getproperty(c::PhysicalConstant{s,T,D,U}, sym::Symbol) where {s,T,D,U}
    if sym === :val
        return ustrip(float(T, c))
    else # fallback to getfield
        return getfield(c, sym)
    end
end

# @constant and @derived_constant macros

"""
    @constant(name, sym, descr, val, def, unit, unc, bigunc, reference) -> PhysicalConstant

Macro to define a new [`PhysicalConstant`](@ref).

The arguments are:

* `name`: a symbol with the long name of the constant.  This symbol is automatically eported
* `sym`: a non-exported alias for the constant
* `descr`: a description of the constant
* `val`: the numerical `Float64` value of the constant, in the reference units
* `def`:  the expression to use to compute the constant in any precision, in the reference units
* `unit`: the reference units
* `unc`: the numerical `Float64` value of the uncertainty, in the reference units
* `bigunc`: the expression to use to compute the uncertainty in any precision, in the reference units
* `reference`: the name of the reference document that defines the constant

```jldoctest
julia> using PhysicalConstants, Unitful

julia> PhysicalConstants.@constant(MyConstant, mc, "A custom constant",
           12.34, BigFloat(1234) / BigFloat(100), u"m/s",
           0.56, BigFloat(56) / BigFloat(100), "My lab notebook")

julia> MyConstant
A custom constant (mc)
Value                         = 12.34 m s^-1
Standard uncertainty          = 0.56 m s^-1
Relative standard uncertainty = 0.045
Reference                     = My lab notebook
```
"""
macro constant(name, sym, descr, val, def, unit, unc, bigunc, reference)
    ename, qname, esym, qsym, eunit, e_val, _bigconvert = _constant_preamble(name, sym, unit, val, def)
    eunc = esc(unc)
    ebigunc = esc(bigunc)
    tag = Threads.atomic_add!(Measurements.tag_counter, UInt64(1))
    quote
       $(_constant_begin(qname, ename, esym, eunit, e_val, _bigconvert))

        function Measurements.measurement(FT::DataType,
                                          ::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U}
            vl = FT($e_val)
            newder = Measurements.empty_der2(vl)
            if iszero($eunc)
                return Measurement{FT}(vl, FT($eunc), UInt64(0), newder) * $eunit
            else
                return Measurement{FT}(vl, FT($eunc), $tag,
                                       Measurements.Derivatives(newder,
                                                                (vl, $eunc, $tag)=>one(FT))) * $eunit
            end
        end
        function Measurements.measurement(::Type{BigFloat},
                                          x::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U}
            vl = _big(x)
            unc = BigFloat($ebigunc)
            newder = Measurements.empty_der2(vl)
            if iszero($eunc)
                return Measurement{BigFloat}(vl, unc, UInt64(0), newder) * $eunit
            else
                return Measurement{BigFloat}(vl, unc, $tag,
                                             Measurements.Derivatives(newder,
                                                                      (vl, unc, $tag)=>one(BigFloat))) * $eunit
            end
        end

        $(_constant_end(qname, ename, qsym, esc(descr), e_val, esc(reference), eunit))
    end
end

"""
    @derived_constant(name, sym, descr, val, def, unit, measure64, measurebig, reference) -> PhysicalConstant

Macro to define a new [`PhysicalConstant`](@ref) derived from another existing `PhysicalConstant`.

The arguments are:

* `name`: a symbol with the long name of the constant.  This symbol is automatically eported
* `sym`: a non-exported alias for the constant
* `descr`: a description of the constant
* `val`: the numerical `Float64` value of the constant, in the reference units
* `def`:  the expression to use to compute the constant in any precision, in the reference units
* `unit`: the reference units
* `measure64`: the numerical `Measurement{Float64}` value of the constant, in the reference units
* `measurebig`: the expression to use to compute the comstamt as a `Measurement{BigFloat}`, in the reference units
* `reference`: the name of the reference document that defines the constant

```jldoctest
julia> using PhysicalConstants, Unitful, Measurements

julia> PhysicalConstants.@constant(MyConstant, mc, "A custom constant",
           12.34, BigFloat(1234) / BigFloat(100), u"m/s",
           0.56, BigFloat(56) / BigFloat(100), "My lab notebook")

julia> MyConstant
A custom constant (mc)
Value                         = 12.34 m s^-1
Standard uncertainty          = 0.56 m s^-1
Relative standard uncertainty = 0.045
Reference                     = My lab notebook

julia> PhysicalConstants.@derived_constant(MyDerivedConstant, mdc, "A custom derived constant",
           96.252, ustrip(big(mc)) * BigFloat(78) / BigFloat(10), u"m/s",
           measurement(mc) * 7.8, measurement(BigFloat, mc)  * BigFloat(78) / BigFloat(10),
           "My lab notebook")

julia> MyDerivedConstant
A custom derived constant (mdc)
Value                         = 96.252 m s^-1
Standard uncertainty          = 4.368 m s^-1
Relative standard uncertainty = 0.045
Reference                     = My lab notebook
```
"""
macro derived_constant(name, sym, descr, val, def, unit, measure64, measurebig, reference)
    ename, qname, esym, qsym, eunit, e_val, _bigconvert = _constant_preamble(name, sym, unit, val, def)
    quote
        $(_constant_begin(qname, ename, esym, eunit, e_val, _bigconvert))

        Measurements.measurement(::Type{Float64},
                                 ::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} =
                                     $(esc(measure64))
        Measurements.measurement(::Type{BigFloat},
                                 ::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} =
                                     $(esc(measurebig))
        Measurements.measurement(FT::DataType,
                                 x::PhysicalConstant{_name($ename),T,D,U}) where {T,D,U} =
                                     convert(Measurement{FT}, ustrip(measurement(x))) * $eunit

        $(_constant_end(qname, ename, qsym, esc(descr), e_val, esc(reference), eunit))
    end
end

"""
    float(::PhysicalConstant{name,T,D,U}) where {T,D,U}
    float(FloatType, ::PhysicalConstant{name,T,D,U}) where {T,D,U}

Return the physical constant as a `Quantity` with the floating type optionally specified by
`FloatType`, `Float64` by default.

```jldoctest
julia> using PhysicalConstants.CODATA2022: G

julia> G
Newtonian constant of gravitation (G)
Value                         = 6.6743e-11 m^3 kg^-1 s^-2
Standard uncertainty          = 1.5e-15 m^3 kg^-1 s^-2
Relative standard uncertainty = 2.2e-5
Reference                     = CODATA 2022

julia> float(G)
6.6743e-11 m^3 kg^-1 s^-2

julia> float(Float32, G)
6.6743f-11 m^3 kg^-1 s^-2
```
"""
float(::PhysicalConstant)

"""
    measurement(::PhysicalConstant{name,T,D,U}) where {T,D,U}
    measurement(FloatType, ::PhysicalConstant{name,T,D,U}) where {T,D,U}

Return the physical constant as a `Quantity` with standard uncertainty.  The floating-point
precision can be optionally specified with the `FloatType`, `Float64` by default.

```jldoctest
julia> using PhysicalConstants.CODATA2022, Measurements

julia> import PhysicalConstants.CODATA2022: μ_0

julia> μ_0
Vacuum magnetic permeability (μ_0)
Value                         = 1.25663706127e-6 N A^-2
Standard uncertainty          = 2.0e-16 N A^-2
Relative standard uncertainty = 1.6e-10
Reference                     = CODATA 2022

julia> measurement(μ_0)
1.25663706127e-6 ± 2.0e-16 N A^-2

julia> measurement(Float32, μ_0)
1.256637e-6 ± 2.0e-16 N A^-2
```
"""
measurement(::PhysicalConstant)

"""
    reference(::PhysicalConstant{name,T,D,U}) where {T,D,U}

Return the reference defined for the physical constant.

```jldoctest
julia> using PhysicalConstants

julia> using PhysicalConstants.CODATA2022: h

julia> h
Planck constant (h)
Value                         = 6.62607015e-34 J s
Standard uncertainty          = (exact)
Relative standard uncertainty = (exact)
Reference                     = CODATA 2022

julia> PhysicalConstants.reference(h)
"CODATA 2022"
```
"""
function reference end

include("promotion.jl")
include("codata2014.jl")
include("codata2018.jl")
include("codata2022.jl")

end # module

module CODATA2022

using PhysicalConstants, Measurements, Unitful, Roots

import Unitful: Ω, A, C, F, Hz, J, kg, K, m, mol, N, Pa, s, T, W
import PhysicalConstants: @constant, @derived_constant

## Helper functions for the Wien displacement law constants
_λf(x) = (x - 5) * exp(x) + 5
_Dλf(x) = (x - 4) * exp(x)
const _λx0 = 4.965114231744276
_λx(T) = find_zero((_λf, _Dλf), T(_λx0), Roots.Newton())

_νf(x) = (x - 3) * exp(x) + 3
_Dνf(x) = (x - 2) * exp(x)
const _νx0 = 2.8214393721220787
_νx(T) = find_zero((_νf, _Dνf), T(_νx0), Roots.Newton())
## end

@constant(FineStructureConstant, α, "Fine-structure constant", 7.297_352_564_3e-3,
          BigFloat(7_297_352_564_3)/BigFloat(10_000_000_000_000), Unitful.NoUnits,
          1.1e-12, BigFloat(11)/BigFloat(10_000_000_000_000), "CODATA 2022")
@constant(BohrRadius, a_0, "Bohr radius", 5.291_772_105_44e-11,
          BigFloat(5_291_772_105_44)/BigFloat(10_000_000_000_000_000_000_000), m,
          8.2e-21, BigFloat(82)/BigFloat(10_000_000_000_000_000_000_000), "CODATA 2022")
@constant(StandardAtmosphere, atm, "Standard atmosphere", 101_325.0, BigFloat(101_325), Pa,
          0.0, BigFloat(0), "CODATA 2022")
@constant(SpeedOfLightInVacuum, c_0, "Speed of light in vacuum", 299_792_458.0,
          BigFloat(299_792_458.0), m / s, 0.0, BigFloat(0), "CODATA 2022")
@constant(VacuumMagneticPermeability, µ_0, "Vacuum magnetic permeability", 1.256_637_061_27e-6,
          BigFloat(1_256_637_061_27)/BigFloat(100_000_000_000_000_000), N * A^-2, 2.0e-16,
          BigFloat(20)/BigFloat(100_000_000_000_000_000), "CODATA 2022")
@constant(VacuumElectricPermittivity, ε_0, "Vacuum electric permittivity", 8.854_187_818_8e-12,
          BigFloat(8_854_187_818_8)/BigFloat(10_000_000_000_000_000_000_000), F * m^-1,
          1.4e-21, BigFloat(14)/BigFloat(10_000_000_000_000_000_000_000), "CODATA 2022")
@constant(ElementaryCharge, e, "Elementary charge", 1.602_176_634e-19,
          BigFloat(1_602_176_634)/BigFloat(10_000_000_000_000_000_000_000_000_000),
          C, 0.0, BigFloat(0.0), "CODATA 2022")
@constant(NewtonianConstantOfGravitation, G, "Newtonian constant of gravitation",
          6.674_30e-11, BigFloat(6_674_30)/BigFloat(10_000_000_000_000_000), m^3 * kg^-1 * s^-2,
          1.5e-15, BigFloat(15)/BigFloat(10_000_000_000_000_000), "CODATA 2022")
@constant(StandardAccelerationOfGravitation, g_n, "Standard acceleration of gravitation",
          9.806_65, BigFloat(9_806_65)/BigFloat(100_000), m * s^-2, 0, 0, "CODATA 2022")
@constant(PlanckConstant, h, "Planck constant", 6.626_070_15e-34,
          BigFloat(6_626_070_15)/BigFloat(1_000_000_000_000_000_000_000_000_000_000_000_000_000_000),
          J * s, 0.0, BigFloat(0.0), "CODATA 2022")
@derived_constant(ReducedPlanckConstant, ħ, "Reduced Planck constant",
                  convert(Float64, ustrip(big(h))/(2 * big(pi))),
                  ustrip(big(h))/(2 * big(pi)), J * s,
                  measurement(h)/2pi, measurement(BigFloat, h)/(2 * big(pi)), "CODATA 2022")
@constant(BoltzmannConstant, k_B, "Boltzmann constant", 1.380_649e-23,
          BigFloat(1_380_649)/BigFloat(100_000_000_000_000_000_000_000_000_000), J * K^-1,
          0.0, BigFloat(0.0), "CODATA 2022")
@constant(BohrMagneton, µ_B, "Bohr magneton", 9.274_010_0657e-24,
          BigFloat(9_274_010_065_7)/BigFloat(10_000_000_000_000_000_000_000_000_000_000_000),
          J * T^-1, 2.9e-33,
          BigFloat(29)/BigFloat(100_00_000_000_000_000_000_000_000_000_000_000), "CODATA 2022")
@constant(ElectronMass, m_e, "Electron mass", 9.109_383_713_9e-31,
          BigFloat(9_109_383_713_9)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000_000),
          kg, 2.8e-40,
          BigFloat(28)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2022")
@constant(NeutronMass, m_n, "Neutron mass", 1.674_927_500_56e-27,
          BigFloat(1_674_927_500_56)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          kg, 8.5e-37,
          BigFloat(85)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2022")
@constant(ProtonMass, m_p, "Proton mass", 1.672_621_925_95e-27,
          BigFloat(1_672_621_925_95)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          kg, 5.2e-37,
          BigFloat(52)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2022")
@constant(AtomicMassConstant, m_u, "Atomic mass constant", 1.660_539_068_92e-27,
          BigFloat(1_660_539_068_92)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          kg, 5.2e-37,
          BigFloat(52)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2022")
@constant(AvogadroConstant, N_A, "Avogadro constant", 6.022_140_76e23,
          BigFloat(6_022_140_760_000_000_000_000_00), mol^-1,
          0.0, BigFloat(0.0), "CODATA 2022")
@derived_constant(MolarGasConstant, R, "Molar gas constant",
                  convert(Float64, ustrip(big(N_A) * big(k_B))),
                  ustrip(big(N_A) * big(k_B)), J * mol^-1 * K^-1,
                  measurement(N_A) * measurement(k_B),
                  measurement(BigFloat, N_A) * measurement(BigFloat, k_B), "CODATA 2022")
@constant(RydbergConstant, R_∞, "Rydberg constant", 10_973_731.568_157,
          BigFloat(10_973_731_568_157)/BigFloat(1_000_000), m^-1,
          1.2e-5, BigFloat(12)/BigFloat(1_000_000), "CODATA 2022")
@derived_constant(StefanBoltzmannConstant, σ, "Stefan-Boltzmann constant",
                  convert(Float64, ustrip(2 * big(pi)^5 * big(k_B)^4 / (15 * big(h)^3 * big(c_0)^2))),
                  ustrip(2 * big(pi) ^ 5 * big(k_B) ^ 4 / (15 * big(h) ^ 3 * big(c_0) ^ 2)), W * m^-2 * K^-4,
                  (2 * pi ^ 5 * measurement(k_B) ^ 4) / (15 * measurement(h) ^ 3 * measurement(c_0) ^ 2),
                  (2 * big(pi) ^ 5 * measurement(BigFloat, k_B) ^ 4) / (15 * measurement(BigFloat, h) ^ 3 * measurement(BigFloat, c_0) ^ 2),
                  "CODATA 2022")
@constant(ThomsonCrossSection, σ_e, "Thomson cross section", 6.652_458_705_1e-29,
          BigFloat(6_652_458_705_1)/BigFloat(1000_000_000_000_000_000_000_000_000_000_000_000_000),
          m^2, 6.2e-38,
          BigFloat(62)/BigFloat(1000_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2022")
@derived_constant(WienWavelengthDisplacementLawConstant, b, "Wien wavelength displacement law constant",
                  convert(Float64, ustrip(big(h) * big(c_0) / (_λx(BigFloat) * big(k_B)))),
                  ustrip(big(h) * big(c_0) / (_λx(BigFloat) * big(k_B))), m * K,
                  measurement(h) * measurement(c_0) / (_λx0 * measurement(k_B)),
                  measurement(BigFloat, h) * measurement(BigFloat, c_0) / (_λx(BigFloat) * measurement(BigFloat, k_B)),
                  "CODATA 2022")
@derived_constant(WienFrequencyDisplacementLawConstant, b′, "Wien frequency displacement law constant",
                  convert(Float64, ustrip(_νx(BigFloat) * big(k_B) / big(h))),
                  ustrip(_νx(BigFloat) * big(k_B) / big(h)), Hz / K,
                  _νx0 * measurement(k_B) / measurement(h),
                  _νx(BigFloat) * measurement(BigFloat, k_B) / measurement(BigFloat, h), "CODATA 2022")
@constant(CharacteristicImpedanceOfVacuum, Z_0, "Characteristic impedance of vacuum",
          376.730_313_412, BigFloat(376_730_313_412)/BigFloat(1_000_000_000), Ω, 5.9e-8,
          BigFloat(59) / BigFloat(1_000_000_000), "CODATA 2022")

end # module CODATA2022

module CODATA2018

using PhysicalConstants, Measurements, Unitful, Roots

import Unitful: Ω, A, C, F, Hz, J, kg, K, m, mol, N, Pa, s, T, W
import PhysicalConstants: @constant, @derived_constant

## Helper functions for the Wien displacement law constants
_λf(x) = (x - 5) * exp(x) + 5
_Dλf(x) = (x - 4) * exp(x)
const _λx0 = 4.965114231744276
_λx(T) = find_zero((_λf, _Dλf), T(_λx0), Roots.Newton())

_νf(x) = (x - 3) * exp(x) + 3
_Dνf(x) = (x - 2) * exp(x)
const _νx0 = 2.8214393721220787
_νx(T) = find_zero((_νf, _Dνf), T(_νx0), Roots.Newton())
## end

@constant(FineStructureConstant, α, "Fine-structure constant", 7.297_352_5693e-3,
          BigFloat(72_973_525_693)/BigFloat(10_000_000_000_000), Unitful.NoUnits,
          1.1e-12, BigFloat(11)/BigFloat(10_000_000_000_000), "CODATA 2018")
@constant(BohrRadius, a_0, "Bohr radius", 5.291_772_109_03e-11,
          BigFloat(529_177_210_903)/BigFloat(10_000_000_000_000_000_000_000), m,
          8e-21, BigFloat(80)/BigFloat(10_000_000_000_000_000_000_000), "CODATA 2018")
@constant(StandardAtmosphere, atm, "Standard atmosphere", 101_325.0, BigFloat(101_325), Pa,
          0.0, BigFloat(0), "CODATA 2018")
@constant(SpeedOfLightInVacuum, c_0, "Speed of light in vacuum", 299_792_458.0,
          BigFloat(299_792_458.0), m / s, 0.0, BigFloat(0), "CODATA 2018")
@constant(VacuumMagneticPermeability, µ_0, "Vacuum magnetic permeability", 1.256_637_062_12e-6,
          BigFloat(125_663_706_212)/BigFloat(100_000_000_000_000_000), N * A^-2, 1.9e-16,
          BigFloat(19)/BigFloat(100_000_000_000_000_000), "CODATA 2018")
@constant(VacuumElectricPermittivity, ε_0, "Vacuum electric permittivity", 8.854_187_8128e-12,
          BigFloat(88_541_878_128)/BigFloat(10_000_000_000_000_000_000_000), F * m^-1,
          1.3e-21, BigFloat(13)/BigFloat(10_000_000_000_000_000_000_000), "CODATA 2018")
@constant(ElementaryCharge, e, "Elementary charge", 1.602_176_634e-19,
          big(1_602_176_634)/big(10_000_000_000_000_000_000_000_000_000),
          C, 0.0, BigFloat(0.0), "CODATA 2018")
@constant(NewtonianConstantOfGravitation, G, "Newtonian constant of gravitation",
          6.674_30e-11, big(667_430)/big(10_000_000_000_000_000), m^3 * kg^-1 * s^-2,
          1.5e-15, big(15)/big(10_000_000_000_000_000), "CODATA 2018")
@constant(StandardAccelerationOfGravitation, g_n, "Standard acceleration of gravitation",
          9.806_65, big(980_665)/big(100_000), m * s^-2, 0, 0, "CODATA 2018")
@constant(PlanckConstant, h, "Planck constant", 6.626_070_15e-34,
          6_626_070_15/1_000_000_000_000_000_000_000_000_000_000_000_000_000_000,
          J * s, 0.0, BigFloat(0.0), "CODATA 2018")
@derived_constant(ReducedPlanckConstant, ħ, "Reduced Planck constant",
                  convert(Float64, ustrip(big(h))/(2 * big(pi))),
                  ustrip(big(h))/(2 * big(pi)), J * s,
                  measurement(h)/2pi, measurement(BigFloat, h)/(2 * big(pi)), "CODATA 2018")
@constant(BoltzmannConstant, k_B, "Boltzmann constant", 1.380_649e-23,
          BigFloat(1_380_649)/BigFloat(100_000_000_000_000_000_000_000_000_000), J * K^-1,
          0.0, BigFloat(0.0), "CODATA 2018")
@constant(BohrMagneton, µ_B, "Bohr magneton", 9.274_010_0783e-24,
          BigFloat(92_740_100_783)/BigFloat(10_000_000_000_000_000_000_000_000_000_000_000),
          J * T^-1, 2.8e-33,
          BigFloat(28)/BigFloat(100_00_000_000_000_000_000_000_000_000_000_000), "CODATA 2018")
@constant(ElectronMass, m_e, "Electron mass", 9.109_383_7015e-31,
          BigFloat(91_093_837_015)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000_000),
          kg, 2.8e-40,
          BigFloat(28)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2018")
@constant(NeutronMass, m_n, "Neutron mass", 1.674_927_498_04e-27,
          BigFloat(167_492_749_804)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          kg, 9.5e-37,
          BigFloat(95)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2018")
@constant(ProtonMass, m_p, "Proton mass", 1.672_621_923_69e-27,
          BigFloat(167_262_192_369)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          kg, 5.1e-37,
          BigFloat(51)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2018")
@constant(AtomicMassConstant, m_u, "Atomic mass constant", 1.660_539_066_60e-27,
          BigFloat(166_053_906_660)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          kg, 5.0e-37,
          BigFloat(50)/BigFloat(100_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2018")
@constant(AvogadroConstant, N_A, "Avogadro constant", 6.022_140_76e23,
          BigFloat(602_214_076_000_000_000_000_000), mol^-1,
          0.0, BigFloat(0.0), "CODATA 2018")
@derived_constant(MolarGasConstant, R, "Molar gas constant",
                  convert(Float64, ustrip(big(N_A) * big(k_B))),
                  ustrip(big(N_A) * big(k_B)), J * mol^-1 * K^-1,
                  measurement(N_A) * measurement(k_B),
                  measurement(BigFloat, N_A) * measurement(BigFloat, k_B), "CODATA 2018")
@constant(RydbergConstant, R_∞, "Rydberg constant", 10_973_731.568_160,
          BigFloat(10_973_731_568_160)/BigFloat(1_000_000), m^-1,
          2.1e-5, BigFloat(21)/BigFloat(1_000_000), "CODATA 2018")
@derived_constant(StefanBoltzmannConstant, σ, "Stefan-Boltzmann constant",
                  convert(Float64, ustrip(2 * big(pi)^5 * big(k_B)^4 / (15 * big(h)^3 * big(c_0)^2))),
                  ustrip(2 * big(pi) ^ 5 * big(k_B) ^ 4 / (15 * big(h) ^ 3 * big(c_0) ^ 2)), W * m^-2 * K^-4,
                  (2 * pi ^ 5 * measurement(k_B) ^ 4) / (15 * measurement(h) ^ 3 * measurement(c_0) ^ 2),
                  (2 * big(pi) ^ 5 * measurement(BigFloat, k_B) ^ 4) / (15 * measurement(BigFloat, h) ^ 3 * measurement(BigFloat, c_0) ^ 2),
                  "CODATA 2018")
@constant(ThomsonCrossSection, σ_e, "Thomson cross section", 6.652_458_7321e-29,
          BigFloat(66_524_587_321)/BigFloat(1000_000_000_000_000_000_000_000_000_000_000_000_000),
          m^2, 6.0e-38,
          BigFloat(60)/BigFloat(1000_000_000_000_000_000_000_000_000_000_000_000_000),
          "CODATA 2018")
@derived_constant(WienWavelengthDisplacementLawConstant, b, "Wien wavelength displacement law constant",
                  convert(Float64, ustrip(big(h) * big(c_0) / (_λx(BigFloat) * big(k_B)))),
                  ustrip(big(h) * big(c_0) / (_λx(BigFloat) * big(k_B))), m * K,
                  measurement(h) * measurement(c_0) / (_λx0 * measurement(k_B)),
                  measurement(BigFloat, h) * measurement(BigFloat, c_0) / (_λx(BigFloat) * measurement(BigFloat, k_B)),
                  "CODATA 2018")
@derived_constant(WienFrequencyDisplacementLawConstant, b′, "Wien frequency displacement law constant",
                  convert(Float64, ustrip(_νx(BigFloat) * big(k_B) / big(h))),
                  ustrip(_νx(BigFloat) * big(k_B) / big(h)), Hz / K,
                  _νx0 * measurement(k_B) / measurement(h),
                  _νx(BigFloat) * measurement(BigFloat, k_B) / measurement(BigFloat, h), "CODATA 2018")
@constant(CharacteristicImpedanceOfVacuum, Z_0, "Characteristic impedance of vacuum",
          376.730_313_668, BigFloat(376_730_313_668)/BigFloat(1000_000_000), Ω, 5.7e-8,
          BigFloat(57) / BigFloat(1000_000_000), "CODATA 2018")

end # module CODATA2018

using PhysicalConstants, Measurements, Unitful
using Test

import PhysicalConstants.CODATA2014: α, atm, c_0, e, ε_0, h, ħ, µ_0

@testset "Base" begin
    @test ustrip(big(h)) == big"6.626070040e-34"
    @test setprecision(BigFloat, 768) do; precision(ustrip(big(c_0))) end == 768
    @test measurement(h) === measurement(h)
    @test iszero(measurement(α) - measurement(α))
    @test isone(measurement(BigFloat, atm) / measurement(BigFloat, atm))
    @test iszero(measurement(BigFloat, ħ) - (measurement(BigFloat, h) / 2big(pi)))
    @test isone(measurement(BigFloat, ħ) / (measurement(BigFloat, h) / 2big(pi)))
    @test PhysicalConstants.reference(PhysicalConstants.CODATA2014.G) == "CODATA 2014"
    @test PhysicalConstants.reference(PhysicalConstants.CODATA2018.G) == "CODATA 2018"
    @test PhysicalConstants.reference(PhysicalConstants.CODATA2022.G) == "CODATA 2022"
end

@testset "Utils" begin
    @test c_0.val === ustrip(float(c_0))
    @test_throws ErrorException h.foo
end

@testset "Promotion" begin
    x = @inferred(inv(μ_0 * c_0 ^ 2))
    T = promote_type(typeof(ε_0), typeof(x))
    u = u"A^2 * kg^-1 * m^-3 * s^4"
    @test promote_type(typeof(α), BigInt) === BigFloat
    @test promote_type(typeof(α), typeof(1u"m/cm")) === Float64
    @test T === Quantity{Float64, dimension(x), typeof(u)}
    @test convert(T, ε_0) === (ε_0 / unit(ε_0)) * u
    @test convert(Float32, α) === float(Float32, α)
    @test uconvert(u"cm/s", c_0) === uconvert(u"cm/s", float(c_0))
end

@testset "Maths" begin
    @testset "$cst" for cst in (PhysicalConstants.CODATA2014,
                                PhysicalConstants.CODATA2018,
                                PhysicalConstants.CODATA2022)
        @test cst.α ≈ @inferred(cst.e^2/(4 * cst.pi * cst.ε_0 * cst.ħ * cst.c_0))
        @test @inferred(cst.α + 2) ≈ 2 + float(cst.α)
        @test @inferred(5 + cst.α) ≈ float(cst.α) + 5
        @test @inferred(cst.α + 2.718) ≈ 2.718 + float(cst.α)
        @test @inferred(-3.14 + cst.α) ≈ float(cst.α) - 3.14
        @test cst.ε_0 ≈ @inferred(1 / (cst.μ_0 * cst.c_0 ^ 2))
        @test @inferred(big(0) + cst.α) == big(cst.α)
        @test @inferred(cst.α * 1.0) == float(cst.α)
        @test (pi ^ 2 * cst.k_B ^ 4) / (60 * cst.ħ ^ 3 * cst.c_0 ^ 2) ≈
            cst.σ atol = measurement(cst.σ).val.err * unit(cst.σ)
    end
end

@testset "Show" begin
    function plain_repr(x)
        io = IOBuffer()
        show(io, "text/plain", x)
        return String(take!(io))
    end
    @test occursin(r"Speed of light in vacuum \(c_0\)
Value                         = 2.99792458e8 m .*
Standard uncertainty          = \(exact\)
Relative standard uncertainty = \(exact\)
Reference                     = CODATA 2014", plain_repr(c_0))
    @test plain_repr(α) ==
        "Fine-structure constant (α)
Value                         = 0.0072973525664
Standard uncertainty          = 1.7e-12
Relative standard uncertainty = 2.3e-10
Reference                     = CODATA 2014"
    @test plain_repr(e) ==
        "Elementary charge (e)
Value                         = 1.6021766208e-19 C
Standard uncertainty          = 9.8e-28 C
Relative standard uncertainty = 6.1e-9
Reference                     = CODATA 2014"
    @test plain_repr(ħ) ==
        "Planck constant over 2pi (ħ)
Value                         = 1.0545718001391127e-34 J s
Standard uncertainty          = 1.2891550390443523e-42 J s
Relative standard uncertainty = 1.2e-8
Reference                     = CODATA 2014"
end

# API Reference

## Types
```@autodocs
Modules = [PhysicalConstants]
Order = [:type]
```

## Functions
```@autodocs
Modules = [PhysicalConstants]
Order = [:function]
```

## Macros
```@autodocs
Modules = [PhysicalConstants]
Order = [:macro]
```

# PhysicalConstants.jl

## Introduction

[`PhysicalConstants.jl`](https://github.com/JuliaPhysics/PhysicalConstants.jl)
provides common physical constants.  They are defined as instances of the new
`Constant` type, which is subtype of `AbstractQuantity` (from
[`Unitful.jl`](https://github.com/PainterQubits/Unitful.jl) package) and can also
be turned into `Measurement` objects (from
[`Measurements.jl`](https://github.com/JuliaPhysics/Measurements.jl) package) at
request.

Constants are grouped into different submodules, so that the user can choose
different datasets as needed.  Currently, 2014, 2018, and 2022 editions of
[CODATA](https://physics.nist.gov/cuu/Constants/) recommended values of the
fundamental physical constants are provided.

## Installation

The latest version of `PhysicalConstants.jl` is available for Julia 1.0 and
later versions, and can be installed with [Julia built-in package
manager](https://julialang.github.io/Pkg.jl/stable/).  After entering the
package manager mode by pressing `]`, run the command

```julia
pkg> add PhysicalConstants
```

## License

The `PhysicalConstants.jl` package is licensed under the MIT "Expat" License.
The original author is [Mosè Giordano](https://github.com/giordano/).

## Usage

You can load the package as usual with `using PhysicalConstants` but this module
does not provide anything useful for the end-users.  You most probably want to
directly load the submodule with the dataset you are interested in.  For
example, for CODATA 2022 load `PhysicalConstants.CODATA2022`:

```jldoctest
julia> using PhysicalConstants.CODATA2022

julia> SpeedOfLightInVacuum
Speed of light in vacuum (c_0)
Value                         = 2.99792458e8 m s^-1
Standard uncertainty          = (exact)
Relative standard uncertainty = (exact)
Reference                     = CODATA 2022

julia> NewtonianConstantOfGravitation
Newtonian constant of gravitation (G)
Value                         = 6.6743e-11 m^3 kg^-1 s^-2
Standard uncertainty          = 1.5e-15 m^3 kg^-1 s^-2
Relative standard uncertainty = 2.2e-5
Reference                     = CODATA 2022
```

`SpeedOfLightInVacuum` and `NewtonianConstantOfGravitation` are two of the
`PhysicalConstant`s defined in the `PhysicalConstants.CODATA2022` module, the
full list of available constants is given below.

`PhysicalConstant`s can be readily used in mathematical operations, using by
default their `Float64` value:

```jldoctest
julia> import PhysicalConstants.CODATA2022: c_0, ε_0, μ_0

julia> 2 * ε_0
1.77083756376e-11 F m^-1

julia> ε_0 - 1 / (μ_0 * c_0 ^ 2)
1.0567555442791707e-23 A^2 s^4 kg^-1 m^-3
```

If you want to use a different precision for the value of the constant, use the
function `float(float_type, constant)`, for example:

```jldoctest
julia> import PhysicalConstants.CODATA2022: c_0, ε_0, μ_0

julia> float(Float32, ε_0)
8.854188f-12 F m^-1

julia> float(BigFloat, ε_0)
8.854187818800000000000000000000000000000000000000000000000000000000000000000059e-12 F m^-1

julia> big(ε_0)
8.854187818800000000000000000000000000000000000000000000000000000000000000000059e-12 F m^-1

julia> big(ε_0) - inv(big(μ_0) * big(c_0)^2)
1.056704162590924117341831987227432956066714823419574007586677144869010778731235e-23 A^2 s^4 kg^-1 m^-3
```

Note that `big(constant)` is an alias for `float(BigFloat, constant)`.

If in addition to units you also want the standard uncertainty associated with
the constant, use `measurement(x)`:

```jldoctest
julia> using Measurements

julia> import PhysicalConstants.CODATA2022: h, ħ

julia> measurement(ħ)
1.0545718176461565e-34 ± 0.0 J s

julia> measurement(Float32, ħ)
1.0545718e-34 ± 0.0 J s

julia> measurement(BigFloat, ħ)
1.054571817646156391262428003302280744722826330020413122421923470598435912734741e-34 ± 0.0 J s

julia> measurement(BigFloat, ħ) / (measurement(BigFloat, h) / (2 * big(pi)))
1.0 ± 0.0
```
